<?php
// This is for Poedit.
function mariginari_etc_poo() {
	$mariginari_plugin_name=__('enhanced tag cloud', 'mariginari');
	$mariginari_plugin_description=__("Improves styling on wp_tag_cloud's output.", 'mariginari');
}

/*
*	Text Domain: mariginari
*    	Plugin URI: http://mummila.net/nuudelisoppa/mariginari-theme-for-wordpress/
* 	Author: Jani Uusitalo
* 	Author URI: http://mummila.net/
*	Plugin Name: enhanced tag cloud
*   	Description: Improves styling on wp_tag_cloud's output.
* 	Version: 9000
*
* 
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program; if not, write to the Free Software
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



function mariginari_tag_cloud($old_cloud) {

	$cloud = explode("\n", $old_cloud);
	foreach (array_keys($cloud) as $tag) {
		$params = explode(" ", $cloud[$tag]);
		if (count($params) > 4) {
			$class = explode("'", $params[2]);
			if (count($class) < 2) continue;
			$class = $class[1];
			$title = explode("'", $params[4]);
			if (count($title) < 1) continue;
			$title = $title[0];
			$params[4] = str_replace('aihe', 'merkintä', str_replace('aihetta', 'merkintää', $title))."'";
			$font_size = explode("'", $params[6]);
			if (count($font_size) < 1) continue;
			$font_size = $font_size[0];
			$font_size = str_replace('pt', '', $font_size);
			$font_size = str_replace(';', '', $font_size);
/*
			$dot = strpos($font_size, '.');
			if ($dot !== false) {
				$font_size = substr($font_size, 0, $dot);
			}
*/
			$font_size = round($font_size);
			$class .= " tag-weight-" . $font_size;
			$params[2] = "class='".$class."'";
		}
		$cloud[$tag] = implode(" ", $params);
	}
	$cloud = "\n" . implode("\n", $cloud) . "\n";
	return $cloud;
}
add_filter('wp_tag_cloud', 'mariginari_tag_cloud');

?>
