<?php
// This is for Poedit.
function mariginari_ftr_poo() {
	$mariginari_plugin_name=__('fuck the rules', 'mariginari');
	$mariginari_plugin_description=__('Mangles posts with typos and such.', 'mariginari');
}

/*
*	Text Domain: mariginari
*    	Plugin URI: http://mummila.net/nuudelisoppa/mariginari-theme-for-wordpress/
* 	Author: Jani Uusitalo
* 	Author URI: http://mummila.net/
*	Plugin Name: fuck the rules
*   	Description: Mangles posts with typos and such.
* 	Version: 9001
*
* 
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program; if not, write to the Free Software
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



// "Because setting a cookie with a value of FALSE will try to delete the cookie,
// you should not use boolean values. Instead, use 0 for FALSE  and 1 for TRUE."
// (http://fi2.php.net/setcookie)
define('MARIGINARI_RESPECTS_THE_RULES', 1);
define('MARIGINARI_FTR_TOGGLER_URL_PARAMETER', 'marigrammari');
define('MARIGINARI_RULES_COOKIE', 'mariginari_respects_the_rules');

define('MARIGINARI_SMILIES_PATH', dirname(__FILE__) . DIRECTORY_SEPARATOR);
define('MARIGINARI_SMILIES_URL', get_settings('siteurl') .'/wp-content/plugins/smilies-themer/');

// Provide means to disable mangling.
// The toggler was adapted from Smart Unread Comments.
if (isset($_GET[MARIGINARI_FTR_TOGGLER_URL_PARAMETER])) {
	mariginari_toggle_mangling();

	// Try to return to referring page.
	if ( isset($_SERVER['HTTP_REFERER']) && $_SERVER['HTTP_REFERER'] != '' ) {
		$location = $_SERVER['HTTP_REFERER'];
	}
	// It ought to be the current page, sans the toggler parameter.
	else {
		$location = 'http'.( empty($_SERVER['HTTPS']) ? '' : 's' ).'://'.$_SERVER["HTTP_HOST"].( str_replace('?'.$_SERVER['QUERY_STRING'], '', $_SERVER['REQUEST_URI']) );
	}
	header ('Location: ' . $location);
}
function mariginari_toggle_mangling() {
	if (mariginari_fucks_with_words()) {
		$new_state = MARIGINARI_RESPECTS_THE_RULES;
		$cookie_age = 3600*24*365;	// 365 days
		$time_now = strtotime(gmdate('Y-m-d H:i:s')) + get_settings('gmt_offset') * 3600;
		$cookie_expires = $time_now + $cookie_age;

	}
	else {
		$new_state = '';
		$cookie_expires = 1;	// 1 s. past epoch
	}

	$cookie_path = parse_url(get_bloginfo('siteurl'));
	if ($cookie_path['path'] == "") {
		$cookie_path['path'] = "/";
	}

	setcookie(MARIGINARI_RULES_COOKIE, $new_state, $cookie_expires, $cookie_path['path']);
}

// Returns the current state: are words mangled or not?
function mariginari_fucks_with_words() {
	$because_of_the_cookie = true;
	if ( isset($_COOKIE[MARIGINARI_RULES_COOKIE]) && $_COOKIE[MARIGINARI_RULES_COOKIE] == MARIGINARI_RESPECTS_THE_RULES) {
		$because_of_the_cookie = false;
	}

	return $because_of_the_cookie;
}

function mariginari_get_mangler_switch() {
	if ( !mariginari_browser_knows_html5() ) {
		return mariginari_get_mangler_switch_html4();
	}

	if (mariginari_fucks_with_words()) {
		$stop='';
		$do='checked="checked" disabled="disabled"';
	}
	else {
		$stop='checked="checked" disabled="disabled"';
		$do='';
	}
	return '<command id="mariginari-mangler-switch-lever" type="radio" radiogroup="mariginari-mangler" label="'.__('Stop breaking the rules!', 'mariginari').'" title="'.__('Stop mangling the content with typos and such.', 'mariginari').'" $stop />
<command id="mariginari-mangler-switch-lever" type="radio" radiogroup="mariginari-mangler" label="'.__('Fuck the rules!', 'mariginari').'" title="'.__('Mangle content with typos and such.', 'mariginari').'" $do />
';
}
function mariginari_browser_knows_html5() {
	return false;
}
function mariginari_get_mangler_switch_html4() {
	$toggler = '?'.MARIGINARI_FTR_TOGGLER_URL_PARAMETER;
	if (mariginari_fucks_with_words()) {
		return '<a id="mariginari-mangler-switch-lever" href="'.$toggler.'" title="'.__('Stop breaking the rules!', 'mariginari').'">'.__('Stop breaking the rules!', 'mariginari').'</a>';
	}
	else {
		return '<a id="mariginari-mangler-switch-lever" href="'.$toggler.'" title="'.__('Fuck the rules!', 'mariginari').'">'.__('Fuck the rules!', 'mariginari').'</a>';
	}
}

function mariginari_mangle_comment($comment_text) {
	global $comment;
	if (get_comment_author($comment->ID) == 'Jani') {
		return mariginari_mangle($comment_text);
	}
	else if ( !mariginari_fucks_with_words() || is_feed() ) {
		return $comment_text;
	}
	else {
		return mariginari_do_smilies($comment_text);
	}
}

// The actual mangling filter.
add_filter('the_content', 'mariginari_mangle', 12);
add_filter('the_title', 'mariginari_mangle', 12);
add_filter('comment_text', 'mariginari_mangle_comment', 12);
add_filter('single_post_title', 'mariginari_mangle', 12);

// Stolen from Smilies Themer.
function mariginari_do_smilies($text) {
	$smileypath = MARIGINARI_SMILIES_PATH . 'Phoenity' . DIRECTORY_SEPARATOR;
	$smileyurl = MARIGINARI_SMILIES_URL . 'Phoenity';
	include($smileypath . 'package-config.php');

	$smilies = $wp_smilies;
	$smiliessearch = array();
	$smiliesreplace = array();
	foreach ( (array) $smilies as $smiley => $img ) {
		$smiliessearch[] = '/(\s|^)'.preg_quote($smiley, '/').'(\s|$)/';
		$smiley_masked = htmlspecialchars(trim($smiley), ENT_QUOTES);
		$smiliesreplace[]  = " <img src='$smileyurl/$img' alt='$smiley_masked' class='wp-smiley' /> ";
	}

	$output = '';
	// HTML loop taken from texturize function, could possible be consolidated
	$textarr = preg_split("/(<.*>)/Us", $text, -1, PREG_SPLIT_DELIM_CAPTURE); // capture the tags as well as in between
	$stop = count($textarr);// loop stuff 
	for ($i = 0; $i < $stop; $i++) { 
		$smcontent = $textarr[$i]; 
		if ((strlen($smcontent) > 0) && ('<' != $smcontent{0})) { // If it's not a tag 
			$smcontent = preg_replace($smiliessearch, $smiliesreplace, $smcontent); 
		} 
		$output .= $smcontent; 
	}
	return $output;
}
function mariginari_ftr_replace($search, $replace, $text) {
	$opening_tag_in_text = explode('<', $text);
	$i = 0;
	foreach ($opening_tag_in_text as $tag) {
		$tag_contents = explode('>', $tag);
		$tag_contents[count($tag_contents)-1] = str_replace($search, $replace, $tag_contents[count($tag_contents)-1]);
		$opening_tag_in_text[$i] = implode('>', $tag_contents);
		$i++;
	}
	$text = implode('<', $opening_tag_in_text);
	return $text;
}
function mariginari_mangle($content) {

	// Don't mangle if disabled, don't mangle feeds or admin area.
	if ( !mariginari_fucks_with_words() || is_feed() || is_admin() ) {
		$content=str_replace('↔', '', $content);
		$content=str_replace('≠', ' ', $content);
		$content=str_replace('←', '-', $content);
		$content=str_replace('→', '-', $content);
		return $content;
	}

	$content = mariginari_do_smilies($content);

	// Punctuation for detecting word boundaries, as well as for
	// the random insertions further down.
	$punctuation = array('/','.',',','?','!',':',';',' ');

	// Replace words with wrong equivalents.
	$mangle_these[] = array(
		'tapahtuu'=>'käy','tapahtui'=>'kävi', 'tapahtunut'=>'käynyt');

	$mangle_these[] = array(
		'kukaan'=>'ketään', 'kukapa'=>'ketäpä', 'kuka'=>'ketä',
		'missä'=>'ketä', 'mistä'=>'ketä', 'missään'=>'ketään',
		'mikään'=>'ketään', 'mikä'=>'ketä', 'mitään'=>'ketään', 'miten'=>'ketä', 'miksi'=>'ketä', 'mitä'=>'ketä');

	foreach ($mangle_these as $mangle_this) {
		foreach (array_keys($mangle_this) as $mangle) {
			$content = mariginari_ftr_replace(ucfirst($mangle), ucfirst($mangle_this[$mangle]), $content);
			foreach ($punctuation as $punct) {
				$content = mariginari_ftr_replace($mangle.$punct, $mangle_this[$mangle].$punct, $content);
			}
		}
	}

	// Replace lätyt with pancakes.
	$mangle_to = array('letuin',
			'letuksi', 'letuiksi',
			'letussa', 'letuissa',
			'letusta', 'letuista',
			'lettuun', 'lettuihin',
			'letulla', 'letuilla',
			'letulta', 'letuilta',
			'letulle', 'letuille', 
			'letutta', 'letuitta',
			'letun', 'lettujen',
			'lettuna', 'lettuina',
			'lettua', 'lettuja',
			'lettuineen', 'letut', 'lettu');
	$mangle_from = array('lätyin',
			'lätyksi', 'lätyiksi',
			'lätyssä', 'lätyissä',
			'lätystä', 'lätyistä',
			'lättyyn', 'lättyihin',
			'lätyllä', 'lätyillä',
			'lätyltä', 'lätyiltä',
			'lätylle', 'lätyille', 
			'lätyttä', 'lätyittä',
			'lätyn', 'lättyjen',
			'lättynä', 'lättyinä',
			'lättyä', 'lättyjä',
			'lättyineen', 'lätyt', 'lätty');
	foreach(array_keys($mangle_from) as $mangle) {
		$content = mariginari_ftr_replace($mangle_from[$mangle], $mangle_to[$mangle], $content);
		$content = mariginari_ftr_replace(ucfirst($mangle_from[$mangle]), ucfirst($mangle_to[$mangle]), $content);
	}
	$mangle_from = array();



	// Replace some nouns with the word 'blog'.
	$mangle_to = array('blogein',
			'blogiksi', 'blogeiksi',
			'blogissa', 'blogeissa',
			'blogista', 'blogeista',
			'blogiin', 'blogeihin',
			'blogilla', 'blogeilla',
			'blogilta', 'blogeilta',
			'blogille', 'blogeille', 
			'blogitta', 'blogeitta',
			'blogin', 'blogien',
			'blogina', 'blogeina',
			'blogia', 'blogeja',
			'blogeineen', 'blogit', 'blogi');

	$mangle_from = array('merkinnöin',
			'merkinnäksi', 'merkinnöiksi',
			'merkinnässä', 'merkinnöissä',
			'merkinnästä', 'merkinnöistä',
			'merkintään', 'merkintöihin',
			'merkinnällä', 'merkinnöillä',
			'merkinnältä', 'merkinnöiltä',
			'merkinnälle', 'merkinnöille', 
			'merkinnättä', 'merkinnöittä',
			'merkinnän', 'merkintöjen',
			'merkintänä', 'merkintöinä',
			'merkintää', 'merkintöjä',
			'merkintöineen', 'merkinnät', 'merkintä');
	foreach(array_keys($mangle_from) as $mangle) {
		$content = mariginari_ftr_replace('blogi'.$mangle_from[$mangle], $mangle_to[$mangle], $content);
		$content = mariginari_ftr_replace('Blogi'.$mangle_from[$mangle], $mangle_to[$mangle], $content);
		$content = mariginari_ftr_replace($mangle_from[$mangle], $mangle_to[$mangle], $content);
		$content = mariginari_ftr_replace(ucfirst($mangle_from[$mangle]), ucfirst($mangle_to[$mangle]), $content);
	}
	$mangle_from = array();

	$mangle_from[] = array('meemein',
			'meemiksi', 'meemeiksi',
			'meemissä', 'meemeissä',
			'meemistä', 'meemeistä',
			'meemiin', 'meemeihin',
			'meemillä', 'meemeillä',
			'meemiltä', 'meemeiltä',
			'meemille', 'meemeille', 
			'meemittä', 'meemeittä',
			'meemin', 'meemien',
			'meeminä', 'meemeinä',
			'meemiä', 'meemejä',
			'meemeineen', 'meemit', 'meemi');
	$mangle_from[] = array('televisioin',
			'televisioksi', 'televisioiksi',
			'televisiossa', 'televisioissa',
			'televisiosta', 'televisioista',
			'televisioon', 'televisioihin',
			'televisiolla', 'televisioilla',
			'televisiolta', 'televisioilta',
			'televisiolle', 'televisioille', 
			'televisiotta', 'televisioitta',
			'television', 'televisioen',
			'televisiona', 'televisioina',
			'televisiota', 'televisioita',
			'televisioineen', 'televisiot', 'televisio');
	$mangle_from[] = array('telkkarein',
			'telkkariksi', 'telkkareiksi',
			'telkkarissa', 'telkkareissa',
			'telkkarista', 'telkkareista',
			'telkkariin', 'telkkareihin',
			'telkkarilla', 'telkkareilla',
			'telkkarilta', 'telkkareilta',
			'telkkarille', 'telkkareille', 
			'telkkaritta', 'telkkareitta',
			'telkkarin', 'telkkarien',
			'telkkarina', 'telkkareina',
			'telkkaria', 'telkkareita',
			'telkkareineen', 'telkkarit', 'telkkari');
	$mangle_from[] = array('tv:in',
			'tv:ksi', 'tv:iksi',
			'tv:ssä', 'tv:issä',
			'tv:stä', 'tv:istä',
			'tv:hen', 'tv:ihin',
			'tv:llä', 'tv:illä',
			'tv:ltä', 'tv:iltä',
			'tv:lle', 'tv:ille', 
			'tv:ttä', 'tv:ittä',
			'tv:n', 'tv:ien',
			'tv:nä', 'tv:inä',
			'tv:tä', 'tv:itä',
			'tv:ineen', 'tv:t');
	$mangle_from[] = array('TV:in',
			'TV:ksi', 'TV:iksi',
			'TV:ssä', 'TV:issä',
			'TV:stä', 'TV:istä',
			'TV:in', 'TV:ihin',
			'TV:llä', 'TV:illä',
			'TV:ltä', 'TV:iltä',
			'TV:lle', 'TV:ille', 
			'TV:ttä', 'TV:ittä',
			'TV:n', 'TV:ien',
			'TV:nä', 'TV:inä',
			'TV:tä', 'TV:itä',
			'TV:ineen', 'TV:t');
	$mangle_from[] = array('radioin',
			'radioksi', 'radioiksi',
			'radiossa', 'radioissa',
			'radiosta', 'radioista',
			'radioon', 'radioihin',
			'radiolla', 'radioilla',
			'radiolta', 'radioilta',
			'radiolle', 'radioille', 
			'radiotta', 'radioitta',
			'radion', 'radioiden',
			'radiona', 'radioina',
			'radioa', 'radioita',
			'radioineen', 'radiot', 'radio');

	foreach ($mangle_from as $mangle_from_this) {
		foreach(array_keys($mangle_from_this) as $mangle) {
			$content = mariginari_ftr_replace($mangle_from_this[$mangle], $mangle_to[$mangle], $content);
			$content = mariginari_ftr_replace(ucfirst($mangle_from_this[$mangle]), ucfirst($mangle_to[$mangle]), $content);
		}
	}

	// Replace correct terms with 'blogist'.
	$mangle_to = array();
	$mangle_to[] = array('blogistein',
			'blogistiksi', 'blogisteiksi',
			'blogistissa', 'blogisteissa',
			'blogistista', 'blogisteista',
			'blogistiin', 'blogisteihin',
			'blogistilla', 'blogisteilla',
			'blogistilta', 'blogisteilta',
			'blogistille', 'blogisteille', 
			'blogistitta', 'blogisteitta',
			'blogistin', 'blogistien',
			'blogistina', 'blogisteina',
			'blogistia', 'blogisteja',
			'blogisteineen', 'blogistit', 'blogisti');
	$mangle_to[] = array('bloggarein',
			'bloggariksi', 'bloggareiksi',
			'bloggarissa', 'bloggareissa',
			'bloggarista', 'bloggareista',
			'bloggariin', 'bloggareihin',
			'bloggarilla', 'bloggareilla',
			'bloggarilta', 'bloggareilta',
			'bloggarille', 'bloggareille', 
			'bloggaritta', 'bloggareitta',
			'bloggarin', 'bloggarien',
			'bloggarina', 'bloggareina',
			'bloggaria', 'bloggareja',
			'bloggareineen', 'bloggarit', 'bloggari');

	$mangle_from = array('blogaajin',
			'blogaajaksi', 'blogaajiksi',
			'blogaajassa', 'blogaajissa',
			'blogaajasta', 'blogaajista',
			'blogaajain', 'blogaajihin',
			'blogaajalla', 'blogaajilla',
			'blogaajalta', 'blogaajilta',
			'blogaajalle', 'blogaajille', 
			'blogaajatta', 'blogaajitta',
			'blogaajan', 'blogaajien',
			'blogaajana', 'blogaajina',
			'blogaajaa', 'blogaajia',
			'blogaajineen', 'blogaajat', 'blogaaja');
	foreach (array_keys($mangle_from) as $mangle) {
		$content = mariginari_ftr_replace($mangle_from[$mangle], $mangle_to[rand(0,1)][$mangle], $content);
		$content = mariginari_ftr_replace(ucfirst($mangle_from[$mangle]), ucfirst($mangle_to[rand(0,1)][$mangle]), $content);
	}



	// Insert random punctuation and typos.
	// http://www.php.net/manual/en/function.chunk-split.php#82546
	// pp = d/p, pt = q/b
	$d = 1;		$q = 1;
	$p = 50;	$b = 100;

	$angle = array_search('<', $punctuation);
	if ($angle !== false) {
		$punctuation[$angle] = '&lt;';
	}
	$angle = array_search('>', $punctuation);
	if ($angle !== false) {
		$punctuation[$angle] = '&gt;';
	}

	$puncts = count($punctuation);
	$prev="";
	$safe=true;
	for($i=0;$i<strlen($content);$i++) {
		$c=mb_substr($content,$i,1,'UTF-8');

		// we're in a tag
		if ($c == "<") {
			$safe=false;
		}

		// we're out of the tag
		else if ($c == ">") {
			$safe=true;
		}

		else if ($safe) {

			// break compounds, mostly wrong.
			if ( mariginari_is_compound($c) ) {
				$c=mariginari_break_compound($c);
			}

			// mis-decapitalization
			else if ( ctype_upper($c) ) {
				if ( rand(1, $p) <= $d ) {
					$c=strtolower($c);
				}
			}

			// inject random punctuation
			else if ( $c == " " && preg_match('/\w/', $prev) ) {
				if ( rand(1, $p) <= $d ) {
					$out.=$punctuation[rand(1,$puncts)];
				}
			}

			// misplace commas
			else if ( $c == "," && $i+1<strlen($content) ) {
				if ( rand(1, $p) <= $d ) {
					if ( mb_substr($content,$i+1,1,'UTF-8') == " " ) {
						$c=" ,";
						$i++;
					}
				}
			}

			// mistype
			else if ( preg_match('/\w/', $c) ) {

				// half the chances for two rolls
				if ( rand(1, $b*2) <= $q ) {

					// botch the key
					$c=mariginari_mangle_character($c);
				}

				else if ( rand(1, $b*2) <= $q && $i+1<strlen($content) ) {
					$d = mb_substr($content,$i+1,1,'UTF-8');

					// botch the order of two keys
					if ( ($d != "<") && (!mariginari_is_compound($d)) ) {
						$c=$d.$c;
						$i++;
					}
				}
			}

			// skip a character
			else if ( rand(1, $b) <= $q ) {
				$prev=mb_substr($c, -1, 1, 'UTF-8');
				continue;
			}
		}

		$out.=$c;
		$prev=mb_substr($c, -1, 1, 'UTF-8');
	}
	$content = $out;


	// ditch trailing punctuation
	$pattern = '/(\.|\!|\?)<\/p>/';
	$replace = '</p>';
	$content = preg_replace($pattern, $replace, $content);



	return $content;
}

function mariginari_break_compound($c) {
	switch ($c) {
		case "↔" :
			if ( rand(1, $b) <= $q ) {
				$c="";
			}
			else {
				$c=" ";
			}
			break;

		case "≠" :
			if ( rand(1, 10) <= 1 ) {
				$c=" ";
			}
			else {
				$c="";
			}
			break;

		default :
			$c=" ";
			break;

	}
	return $c;
}

function mariginari_is_compound($c) {
	return ( ($c == "↔") || ($c == "→") || ($c == "←") || ($c == "≠") );
}

// Simulate typos.
function mariginari_mangle_character($c = '') {
	if ($c === '') {
		$chars = "§`'\"-.,+<abcdefghijklmnopqrstuvwxyz1234567890";
	}
	switch ($c) {
		case "q" :
		$chars = "§12qwas";
		break;
		case "1" :
		$chars = "§12qw";
		break;
		case "2" :
		$chars = "123qw";
		break;
		case "3" :
		$chars = "234we";
		break;
		case "4" :
		$chars = "345er";
		break;
		case "5" :
		$chars = "456rt";
		break;
		case "6" :
		$chars = "567ty";
		break;
		case "7" :
		$chars = "678yu";
		break;
		case "8" :
		$chars = "789ui";
		break;
		case "9" :
		$chars = "890io";
		break;
		case "0" :
		$chars = "90+op";
		break;
		case "q" :
		$chars = "§12qwas";
		break;
		case "w" :
		$chars = "23qweasd";
		break;
		case "e" :
		$chars = "34wersd";
		break;
		case "r" :
		$chars = "45ertdf";
		break;
		case "t" :
		$chars = "56rtyfg";
		break;
		case "y" :
		$chars = "67tyugh";
		break;
		case "u" :
		$chars = "78tyuhj";
		break;
		case "i" :
		$chars = "89uiojk";
		break;
		case "o" :
		$chars = "90iopkl";
		break;
		case "p" :
		$chars = "0+opålö";
		break;
		case "a" :
		$chars = "qwas<z";
		break;
		case "s" :
		$chars = "qweasdzx";
		break;
		case "d" :
		$chars = "wersdfxc";
		break;
		case "f" :
		$chars = "ertdfgxcv";
		break;
		case "g" :
		$chars = "rtyfghvb";
		break;
		case "h" :
		$chars = "tyughjbn";
		break;
		case "j" :
		$chars = "yuihjknm";
		break;
		case "k" :
		$chars = "uiojklm,";
		break;
		case "l" :
		$chars = "iopklö,.";
		break;
		case "z" :
		$chars = "as<zx";
		break;
		case "x" :
		$chars = "asdzxc";
		break;
		case "c" :
		$chars = "sdfxcv";
		break;
		case "v" :
		$chars = "dfgcvb";
		break;
		case "b" :
		$chars = "ghjvbn";
		break;
		case "n" :
		$chars = "hjkbnm";
		break;
		case "m" :
		$chars = "jklnm,";
		break;
		default :
		$chars = "§`'\"-.,+<abcdefghijklmnopqrstuvwxyz1234567890";
		break;
	}
	$d = htmlspecialchars(mb_substr($chars, rand(0,strlen($chars)-1), 1, 'UTF-8'));

	if ( ctype_upper($c) ) return strtoupper($d);
}

?>
