<?php
// This is for Poedit.
function mariginari_iwid_poo() {
	$mariginari_plugin_name=__('iframe widget', 'mariginari');
	$mariginari_plugin_description=__('Lets you smuggle iframes and stuff into your sidebar.', 'mariginari');
}

/*
*	Text Domain: mariginari
*    	Plugin URI: http://mummila.net/nuudelisoppa/mariginari-theme-for-wordpress/
* 	Author: Jani Uusitalo
* 	Author URI: http://mummila.net/
*	Plugin Name: iframe widget
*   	Description: Lets you smuggle iframes and stuff into your sidebar.
* 	Version: 9001
*
* 
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program; if not, write to the Free Software
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Rips off on http://alax.info/blog/tag/wp-googletalk.

class Mariginari_Iframe_Widget extends WP_Widget {
	function Mariginari_Iframe_Widget() {
		// widget actual processes
		parent::WP_Widget(false, $name = __('iframe widget', 'mariginari'), array(
			'description' => __('Lets you smuggle iframes and stuff into your WPMU sidebar.', 'mariginari')
		));
	}
 
	function form($instance) {
		// outputs the options form on admin
		$title = esc_attr($instance['title']);
		$iframetext = esc_attr($instance['iframetext']);

		// Here is our little form segment. Notice that we don't need a
		// complete form. This will be embedded into the existing form.
		echo '<p style="text-align: right"><label for="'.$this->get_field_id('title').'">'.__('Title:&nbsp;', 'mariginari')
			.'<input style="width: 200px" id="'.$this->get_field_id('title')
			.'" name="'.$this->get_field_name('title').'" type="text" value="'.$title.'" /></label></p>';
		echo '<p style="text-align: right"><label for="'.$this->get_field_id('iframetext').'">'.__('Text:&nbsp;')
			.'<textarea style="width: 200px" id="'.$this->get_field_id('iframetext')
			.'" name="'.$this->get_field_name('iframetext').'">'.$iframetext.'</textarea></label></p>';
	}

	function update($new_instance, $old_instance) {
		// processes widget options to be saved
		return $new_instance;
	}
 
	function widget($args, $instance) {
		extract($args);

		$title = $instance['title'];
		$iframetext = $instance['iframetext'];

		echo $before_widget;
		if($title) {
			echo $before_title . $title . $after_title;
		}
		echo '<div class="mariginariframe">' . $iframetext . '</div>';
		echo $after_widget;
	}
 
}
function mariginari_register_iframe_widget() {
	register_widget('Mariginari_Iframe_Widget');
}
add_action('init', 'mariginari_register_iframe_widget', 1);

?>
