<!doctype html>
<html <?php language_attributes(); ?>>
<head>

	<meta http-equiv="Content-Type" content="text/html; charset=<?php bloginfo('charset'); ?>" />
	<meta name="generator" content="WordPress <?php bloginfo('version'); ?>" />
	<link rel="me" type="text/html" href="http://www.google.com/profiles/jani.uusitalo" /> 

	<link rel="stylesheet" type="text/css" href="<?php bloginfo('stylesheet_url'); ?>" media="screen" />
	<link rel="stylesheet" type="text/css" href="<?php bloginfo('template_url'); ?>/print.css" media="print" />
	<?php if ($_SERVER['SERVER_NAME'] != 'mummila.net') echo '<link rel="stylesheet" type="text/css" href="'.get_bloginfo('template_url').'/lab.css" media="screen" />'; ?>

	<!--[if IE]><link rel="stylesheet" href="<?php bloginfo('template_directory'); ?>/ie.css" media="screen" type="text/css" /><![endif]-->
	<!--[if lte IE 7]>
	<link rel="stylesheet" href="<?php bloginfo('template_directory'); ?>/ie7.css" media="screen" type="text/css" />
	<script src="<?php bloginfo('template_directory'); ?>/focus.js" type="text/javascript"></script><![endif]-->
	<!--[if lte IE 6]>
	<link rel="stylesheet" href="<?php bloginfo('template_directory'); ?>/ie6.css" media="screen" type="text/css" />
	<![endif]-->

	<link rel="shortcut icon" href="<?php bloginfo('template_url'); ?>/images/favicon.png" />
	<link rel="pingback" href="<?php bloginfo('pingback_url'); ?>" />

	<title>
		<?php
		if ( is_page('Home') ) {
			bloginfo('name'); 
		}
		else if ( is_search() ) {
			if ( wp_specialchars($s,1) != ' ') {
				printf( __('Search Results for &#39;%s&#39; on %s', 'mariginari'),
					trim(wp_specialchars($s,1)), get_bloginfo('name') );
			}
			else {
				printf( __('%s - No search query entered!', 'mariginari'), get_bloginfo('name') );
			}
		}
		else if ( is_404() ) {
			printf( __('%s - Refining your search', 'mariginari'), get_bloginfo('name') );
		}
		else if ( have_posts() ) {
			wp_title(':', true, 'right');
			bloginfo('name');
		}
		else {
			bloginfo('name');
		}
		?>
	</title>

	<?php
	if ( is_singular() ) {
		wp_enqueue_script( 'comment-reply' );
	}
	?>

	<?php wp_head(); ?>
	<?php wp_get_archives('type=monthly&format=link'); ?>

	<link rel="alternate" type="application/rss+xml" title="RSS: Janin putkaradio" href="/marginaali/feed/putkaradio/" />
</head>

<body id="top">
<?php
	/*
		Since <body> is taken by the bottom background image, this
		outermost <div> is used to lay out the top background.
	*/ ?>
<div id="wrapper">

	<div class="nav quick" id="access">
		<ul>
			<li><a href="#content"><?php _e('Go to content', 'mariginari') ?></a></li>
			<li><a href="#mariginari-bar"><?php _e('Go to mariginari bar', 'mariginari') ?></a></li>
			<li><a href="#footer"><?php _e('Go to footer', 'mariginari') ?></a></li>
		</ul>
	</div>

<div id="mariginari">

	<div class="header" id="mariginari-title">
		<h1><a href="<?php bloginfo('url'); ?>"	title="<?php bloginfo('name'); ?>"><?php bloginfo('name'); ?></a></h1>
		<h2><?php bloginfo('description'); ?></h2>

		<?php echo $GLOBALS['mariginari']->get_tabs(); ?>
	</div><!-- end header -->

	<div class="section" id="mariginari-body">

		<div class="section content blog<?php if ( is_search() ) echo ' search-results'; ?>" id="mariginari-content">
<?php ?>
