<?php
// This is for Poedit.
function mariginari_marivision_widget_poo() {
	$mariginari_plugin_name=__('marivision widget', 'mariginari');
	$mariginari_plugin_description=__('Posts your marivision picture into your sidebar.', 'mariginari');
}

/*
*	Text Domain: mariginari
*    	Plugin URI: http://mummila.net/nuudelisoppa/mariginari-theme-for-wordpress/
* 	Author: Jani Uusitalo
* 	Author URI: http://mummila.net/
*	Plugin Name: marivision widget
*   	Description: Posts your marivision picture into your sidebar.
* 	Version: 9001
*
* 
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program; if not, write to the Free Software
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

define ('MARIVISION', dirname(__FILE__).'/marivision/marivision.jpg');
define ('MARIVISION_OFF_AIR', dirname(__FILE__).'/marivision/marivision-off-air.jpg');

// Generate style sheet.
if ($_GET['mariginaristyle'] == 'marivision') {
	header("Content-type: text/css");
	include("../../../wp-load.php");
	return mariginari_get_marivision_style();
}
else if ($_GET['marivision']) {
	$pic_to_show = MARIVISION;
	$picemtime = filemtime(MARIVISION);
	if ( !$picemtime ) {
		if ( !file_exists(MARIVISION_OFF_AIR) ) {
			header("HTTP/1.1 404 Not Found");
			header("Status: 404 Not Found");
			exit;
		}
		else {
			$pic_to_show = MARIVISION_OFF_AIR;
		}
	}
	else {
		$pic_age_in_seconds = (date('U') - $picemtime);
		if ($pic_age_in_seconds > 90) {
			$pic_to_show = MARIVISION_OFF_AIR;
		}
	}

	header ("Content-type: image/jpeg");
	passthru('convert '.$pic_to_show.' -crop 260x195+30+22 -resize 130x98 -');
	exit;
}
// Hook up generated style sheet.
if (function_exists('add_action')) {
	add_action('wp_print_styles', 'mariginari_marivision_style');
}
function mariginari_marivision_style() {
	wp_enqueue_style('mariginari-marivision-style', WP_PLUGIN_URL.'/'.plugin_basename(__FILE__).'?mariginaristyle=marivision',array(), '9001', 'all');
}



class Mariginari_Marivision_Widget extends WP_Widget {
	function Mariginari_Marivision_Widget() {
		// widget actual processes
		parent::WP_Widget(false, $name = __('marivision widget', 'mariginari'), array(
			'description' => __('Posts your marivision picture into your sidebar.', 'mariginari')
		));
	}
 
	function form($instance) {
		// outputs the options form on admin
		$title = esc_attr($instance['title']);
		$marivision_image_url = esc_attr($instance['marivision-image-url']);
		$marivision_page_url = esc_attr($instance['marivision-page-url']);

		echo '<p style="text-align: right"><label for="'.$this->get_field_id('title').'">'.__('Title:', 'mariginari')
			.'<input style="width: 200px" id="'.$this->get_field_id('title')
			.'" name="'.$this->get_field_name('title').'" type="text" value="'.$title.'" /></label></p>';
		echo '<p style="text-align: right"><label for="'.$this->get_field_id('marivision-page-url').'">'.__('Cam page URL:')
			.'<textarea style="width: 200px" id="'.$this->get_field_id('marivision-page-url')
			.'" name="'.$this->get_field_name('marivision-page-url').'">'.$marivision_page_url.'</textarea></label></p>';
	}

	function update($new_instance, $old_instance) {
		// processes widget options to be saved
		return $new_instance;
	}
 
	function widget($args, $instance) {
		extract($args);

		$title = $instance['title'];
		$number = $this->number;
		$marivision_page_url = $instance['marivision-page-url'];
		$marivision_image_url = WP_PLUGIN_URL.'/'.plugin_basename(__FILE__).'?marivision=on';
		list($width, $height, $type, $attr) = @getimagesize($marivision_image_url);
		$width = ($width == 0 ? '' : 'width:'.$width.'px;');
		$height = ($height == 0 ? '' : 'height:'.$height.'px;');
		echo $before_widget;
		echo '<a
			class="mariginari-marivision-link"
			id="mariginari-marivision-link-'.$number.'"
			title="'.__('Webcam view or random screenshot', 'mariginari').'"
			href="'.$marivision_page_url.'"
			style="background: url('."'".$marivision_image_url."'".') no-repeat top left;'.$width.$height.'"';
		echo '>';
		if ($title) {
			echo $before_title . $title . $after_title;
		}
		echo '</a>';
		echo '
<script type="text/javascript">
setInterval(function() {
	var marilink = document.getElementById("mariginari-marivision-link-'.$number.'");
	marilink.style.backgroundImage = \'url("'.$marivision_image_url.'&amp;maripara=\'+Math.random()+\'")\';
}, 60000);
</script>';
		echo $after_widget;
	}
 
}
function mariginari_register_marivision_widget() {
	register_widget('Mariginari_Marivision_Widget');
}
add_action('init', 'mariginari_register_marivision_widget', 1);

function mariginari_get_marivision_style() {

?>@charset "UTF-8";
.mariginari-marivision-link {
	position:relative;
	top:25px;
	left:25px;
	text-decoration:none;
	display:block;
	margin:0;
	padding:0;
	color:white;
	-webkit-border-radius: 30px !important;
	-moz-border-radius: 30px !important;
	border-radius: 30px !important;
}
.mariginari-marivision-link > * {
	font-size: 18px !important;
	position:relative;
	top:55px;
	left:10px;
	display:inline;
	line-height:1em;
	color:transparent !important;
	text-shadow:2px 2px 3px transparent !important;
	margin:0 !important;
}
.mariginari-marivision-link:hover {
	color:white;
	text-decoration:none !important;
}
li[id|='mariginari_marivision_widget'] {
	margin:0 auto !important;
	padding: 0 !important;
	width:180px;
	height:180px;
	background: url('<?php echo WP_PLUGIN_URL.'/mariginari/marivision/marivision-noise.gif'; ?>') no-repeat top left;
	background-color: transparent !important;
	-webkit-border-radius: 0;
	-moz-border-radius: 0;
	border-radius: 0;
}
<?php
}



?>
