<?php
// This is for Poedit.
function mariginari_video_poo() {
	$mariginari_plugin_name=__('video', 'mariginari');
	$mariginari_plugin_description=__('Provides shortcode for embedding HTML5 video.', 'mariginari');
}

/*
*	Text Domain: mariginari
*    	Plugin URI: http://mummila.net/nuudelisoppa/mariginari-theme-for-wordpress/
* 	Author: Jani Uusitalo
* 	Author URI: http://mummila.net/
*	Plugin Name: video
*   	Description: Provides shortcode for embedding HTML5 video.
* 	Version: 9001
*
* 
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program; if not, write to the Free Software
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



if (function_exists('add_shortcode')) {
	add_shortcode(__('oggvideo', 'mariginari'), 'mariginari_video');
	add_shortcode(__('source', 'mariginari'), 'mariginari_video_source');
	if (__('source', 'mariginari') != 'source') {
		add_shortcode('source', 'mariginari_video_source');
	}
}
function mariginari_video($atts = null, $content = null) {
	$default_switches = array(
		'preload' => false,
		'autoplay' => false,
		'loop' => false,
		'controls' => true
	);
	$default_dimensions = array(
		'width' => '300',
		'height' => '225'
	);
	extract(  shortcode_atts( array_merge($default_switches, $default_dimensions), $atts )  );
	
	$video_tag = '<video';
	foreach (array_keys($default_switches) as $default) {
		if ($default_switches[$default]) {
			$video_tag .= ' '.$default;
		}
	}
	$video_tag .= ' width="'.$default_dimensions['width'].'"';
	$video_tag .= ' height="'.$default_dimensions['height'].'"';
	$video_tag .= '>';

	$content = do_shortcode($content);

	$video_closing_tag .= '</video>';

	return $video_tag . $content . $video_closing_tag;
}
function mariginari_video_source($atts = null, $content = null) {
	extract(  shortcode_atts( array('type' => false), $atts )  );
	if ($type == false) {
		$ext = strlen($content > 2) ? substr($content, -3) : $content;
		if ($ext == 'ogg' || $ext == 'ogv') {
			$type = 'video/ogg';
		}
		else if ($ext == 'mp4') {
			$type = 'video/mp4';
		}
	}
	return '<source src="'.$content.'"'.($type ? ' type="'.$type.'"' : '').'>';
}

?>
